/* This test checks whether the MPI library supports external32 packing
   of the types transfered by YAC (see definition of get_mpi_datatype
   in ../../src/communicator_mpi.c) */

#include <stdint.h>
#include <limits.h>
#include <mpi.h>
#include <stdio.h>
#include <stdint.h>

char buf[100]; // should be enough to keep all the packed variables
MPI_Aint position = 0;
#define PACK_EXTERNAL(mpi_type) \
  printf("Packing " #mpi_type "\n"); \
  MPI_Pack_external( \
    "external32", &mpi_type ## _var, 1, mpi_type, buf, sizeof(buf), &position);

double MPI_DOUBLE_var;
unsigned int MPI_UNSIGNED_var;
signed int MPI_INT_var;
unsigned char MPI_BYTE_var;
char MPI_CHAR_var;
char MPI_PACKED_var;
uint64_t MPI_UINT64_T_var;


int main(int argc, char *argv[])
{
  MPI_Init(&argc, &argv);

  PACK_EXTERNAL(MPI_DOUBLE)
  PACK_EXTERNAL(MPI_UNSIGNED)
  PACK_EXTERNAL(MPI_INT)
  PACK_EXTERNAL(MPI_BYTE)
  PACK_EXTERNAL(MPI_CHAR)
  PACK_EXTERNAL(MPI_PACKED)
  PACK_EXTERNAL(MPI_UINT64_T)

  MPI_Finalize();
  return 0;
}

