/**
 * @file test_function.h
 *
 * @copyright Copyright  (C)  2018 DKRZ, MPI-M
 *
 * @version 1.0
 *
 * @author Moritz Hanke <hanke@dkrz.de>
 *         Rene Redler  <rene.redler@mpimet.mpg.de>
 *
 */
/*
 * Keywords:
 *
 * Maintainer: Moritz Hanke <hanke@dkrz.de>
 *             Rene Redler  <rene.redler@mpimet.mpg.de>
 *
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * YAC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
 *
 */
#ifndef TEST_FUNCTION
#define TEST_FUNCTION
#include <math.h>
#include "grid.h"
#include "geometry.h"

static inline double test_func(double lon, double lat) {

  double tmp = sin(lon * 2.0);
  return tmp * cos(lat * 3.0);
}

static inline double test_func_deg(double lon, double lat) {

  return test_func(lon * YAC_RAD, lat * YAC_RAD);
}

static inline double test_func_point(struct point p) {

  return test_func(p.lon, p.lat);
}

#endif // TEST_FUNCTION

