package de.mpg.mpimet.yacgui.ui.dialog.tabpanel;

import javax.swing.text.BadLocationException;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.text.AttributeSet;
import javax.swing.text.DocumentFilter;



public class TimelagInputfilter extends DocumentFilter {

	  private Pattern pattern;
	  private String  newStr;

	    public TimelagInputfilter(String pat) {
	        pattern = Pattern.compile(pat);
	    }
	    
	    
	    /**
	     * can not enter "-" as the first digit or before an existing number value 
	     * but in the middle or as a part of non-digit sting is allowed
		 * @param fb FilterBypass
		 * @param offset the offset into the document to insert the content gt 0
		 * @param string the string to insert
		 * @param attr the attributes to associate with the inserted content 
		 */
	    public void insertString(FilterBypass fb, int offset, String string, AttributeSet attr)
	            throws BadLocationException {
	    	if(offset == 0)
	    		newStr = string + fb.getDocument().getText(0, fb.getDocument().getLength());
	    	else
	    		newStr = fb.getDocument().getText(0, fb.getDocument().getLength()) + string;
	    	
	        Matcher m = pattern.matcher(newStr);
	        if(m.matches())
	        {
		        replace(fb,offset,fb.getDocument().getLength(),null,attr);
	        }
	        else {
	        	super.insertString(fb, offset, string, attr); 
	        }
	    }

	    public void replace(FilterBypass fb, int offset,
	                        int length, String string, AttributeSet attr) throws
	            BadLocationException {

	        if(length > 0) fb.remove(offset, length);
	        insertString(fb, offset, string, attr);
	    }
}