/**
 * @file communicator_local.h
 * @brief routines for using of local communicators
 *
 * Local communicators are mainly used for testing and debugging purposes. They allow the
 * simulation of a parallel application within a serial program.
 *
 * @copyright Copyright  (C)  2013 Moritz Hanke <hanke@dkrz.de>
 *
 * @version 1.0
 * @author Moritz Hanke <hanke@dkrz.de>
 */
/*
 * Keywords:
 * Maintainer: Moritz Hanke <hanke@dkrz.de>
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * YAC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
 */

#ifndef COMMUNICATOR_LOCAL_H
#define COMMUNICATOR_LOCAL_H

#include "communicator.h"

/** \example test_communicator_local.c
 * These are some examples on how to work with a local communicator.
 */

struct communicator * yac_local_comm_new();
struct communicator * yac_named_local_comm_new(
   struct communicator * parent_comm, char const * name);
   // name local comm is a special communicator, which is necessary because comm splitting
   // is problematic for local comms
int yac_is_local_comm(struct communicator * comm);
#endif // COMMUNICATOR_LOCAL_H

