/**
 * @file test_read_icon.c
 *
 * @copyright Copyright  (C)  2013 DKRZ, MPI-M
 *
 * @version 1.0
 *
 * @author Moritz Hanke <hanke@dkrz.de>
 *         Rene Redler  <rene.redler@mpimet.mpg.de>
 *
 */
/*
 * Keywords:
 *
 * Maintainer: Moritz Hanke <hanke@dkrz.de>
 *             Rene Redler  <rene.redler@mpimet.mpg.de>
 *
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * YAC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
 *
 */
#include <stdlib.h>

#include "tests.h"
#include "test_common.h"
#include "read_icon_grid.h"
#include "grid.h"
#include "grid2vtk.h"

int main(void) {

   if (!file_exists("icon_grid_R02B00.nc"))
      return EXIT_SKIP_TEST;

   struct grid * icon_grid = read_icon_grid("icon_grid_R02B00.nc");

   if (yac_get_num_grid_cells(icon_grid) != 80)
      PUT_ERR("wrong number of grid cells");

#define WRITE_VTK_GRID_FILE
#ifdef WRITE_VTK_GRID_FILE
   yac_write_grid_to_file(icon_grid, "icon");
#endif // WRITE_VTK_GRID_FILE

   yac_delete_grid(icon_grid);

   return TEST_EXIT_CODE;
}

